#include "testlib.h"

using namespace std;

const int32_t MAXN = 100'000;
const int32_t MAXC = 1'000'000'000;

struct Bound {
    long long n, x;
};

int group;

vector<Bound> MAX{
    // 0: sample
    {MAXN, MAXC},
    // 1: n, ai <= 100
    {100, 100},
    // 2: ai <= 100
    {MAXN, 100},
    // 3
    {MAXN, MAXC},
};

void checkGroup(int n, vector<int>& a) {
    ensuref(group >= 0 && group <= 3, "Incorrect group: %d", group);
    ensuref(n <= MAX[group].n, "wrong n for group %d", group);
    int mx = *max_element(a.begin(), a.end());
    int mn = *min_element(a.begin(), a.end());
    ensuref(mx <= MAX[group].x, "wrong ai for group %d", group);
    ensuref(-mn <= MAX[group].x, "wrong ai for group %d", group);
}


int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    group = validator.group().empty() ? 0 : atoi(validator.group().c_str());
    int32_t n = inf.readInt(1, MAXN, "n");
    inf.readEoln();
    vector<int32_t> a = inf.readInts(n, -MAXC, MAXC, "a[i]");
    inf.readEoln();
    inf.readEof();
    checkGroup(n, a);
}
