#include "testlib.h"

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int t;
int n;
ll h;
ll k;
ll s;
ll max_seg_len;
vector<pair<ll, ll>> segs;

void update_seg(ll &l, ll &r, ll bot, ll top) {
    assert((r - l) % (k + 1) == 0);
    l -= 1;
    r += k;
    while (l <= bot) {
        l += k + 1;
    }
    while (r >= top) {
        r -= k + 1;
    }
}

void fix_max_seg_len(pair<ll, ll> &seg, ll &curl, ll &curr) {
    if (seg.second - seg.first <= max_seg_len) {
        return;
    }
    while (curr + 1 - (curl - 1) > max_seg_len) {
        if (rnd.next(0, 1)) {
            curl += k + 1;
        } else {
            curr -= k + 1;
        }
    }
    seg.first = rnd.next(max(1ll, curr + 1 - max_seg_len), curl - 1);
    seg.second = rnd.next(curr + 1, min(seg.first + max_seg_len, h));
}

void generate_long_increasing(bool have_to_kill) {
    int i = 0;
    s = rnd.next(2ll, h - 1);
    segs.resize(n);
    segs[0] = {s - 1, s + 1};
    ll curl = s;
    ll curr = s;
    bool killed = false;
    int deapth_pos = max(rnd.next(0, 1), rnd.next(0, 1));
    while (i < n - 1) {
        int mx_pos = n - 1;
        mx_pos = min<int>(mx_pos, i + 2 * (h / k) + 4);
        mx_pos = min<int>(mx_pos, i + 2 * (max_seg_len / k) + 4);
        int j = rnd.next(i + 1, mx_pos);
        bool full_free = rnd.next(0, 1);
        while (i + 1 < j) {
            ++i;
            update_seg(curl, curr, 1, h);
            assert(curl <= curr);
            segs[i] = {curl - 1, curr + 1};
            if (rnd.next(0, 1)) {
                segs[i].first = rnd.next(1ll, curl - 1);
            }
            if (rnd.next(0, 1)) {
                segs[i].second = rnd.next(curr + 1, h);
            }
            if (full_free) {
                segs[i] = {1, h};
            }
            fix_max_seg_len(segs[i], curl, curr);
        }
        ++i;
        assert(i == j);
        update_seg(curl, curr, 1, h);
        ll len = (curr - curl) / (k + 1) + 1;
        if (!killed and have_to_kill and i >= deapth_pos) { // now I want to kill!
            killed = true;
            if (curl >= 3 and (rnd.next(0, 3) == 0 or curl == curr)) {
                segs[i].first = 1;
                segs[i].second = curl;
                segs[i].first = max(segs[i].first, segs[i].second - max_seg_len);
            } else if (curr <= h - 2 and (rnd.next(0, 3) == 0 or curl == curr)) {
                segs[i].first = curr;
                segs[i].second = h;
                segs[i].second = min(segs[i].second, segs[i].first + max_seg_len);
            } else {
                assert(curl < curr);
                segs[i].first = curl;
                segs[i].second = curl + k + 1;
            }
            curl = segs[i].first + 1;
            curr = segs[i].second - 1;
            if ((curr - curl) % (k + 1) != 0) {
                ll d = (curr - curl) % (k + 1);
                if (rnd.next(0, 1)) {
                    curl += d;
                } else {
                    curr -= d;
                }
            }
        } else {
            ll dl = 0;
            ll dr = 0;
            if (rnd.next(0, 1)) {
                dl = rnd.next(0ll, len - 1);
                dr = len - dl - 1;
            } else {
                dr = rnd.next(0ll, len - 1);
                dl = rnd.next(0ll, len - dr - 1);
            }
            for (int i = 0; i < dl; i += 1) {
                curl += k + 1;
            }
            for (int i = 0; i < dr; i += 1) {
                curr -= k + 1;
            }
            segs[i] = {curl - 1, curr + 1};
        }
        fix_max_seg_len(segs[i], curl, curr);
    }
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    t = opt<int>("t");
    n = opt<int>("n");
    h = opt<ll>("h");
    k = opt<ll>("k");
    max_seg_len = opt<ll>("max_seg_len", h);

    cout << t << "\n";

    for (int test_id = 0; test_id < t; test_id += 1) {
        generate_long_increasing(rnd.next(0, 1));
        cout << n << " " << h << " " << k << " " << s << "\n";
        for (auto [bot, top] : segs) {
            cout << bot << " " << top << "\n";
        }
    }

    return 0;
}
